// C Header File
// Created 2001-06-30; 15:26:38

/*
==================
check_ai_bounch
This function returns TRUE, if the ai is getting to close to
an object.. if it has his way clear, it returns FALSE.. whitch
will be used as "should i turn now" and this function returns TRUE (turn)
or false (No, your ways is still clear) 
Note that it will either move, or turn.. This way two monsters walking
up against eachother, will BOTH turn.
==================
*/
int check_ai_bounch(int monster_nr)
{
	int x=monster_array[monster_nr][0],y=monster_array[monster_nr][1];
  SetPlane (LIGHT_PLANE);
	if ((monster_array[monster_nr][2]==RIGHT) &&GetPix(x+8,y+1)) return TRUE;	
	if ((monster_array[monster_nr][2]==LEFT) && GetPix(x-1,y+1)) return TRUE;
  SetPlane (DARK_PLANE);
	if ((monster_array[monster_nr][2]==RIGHT) &&GetPix(x+8,y+1)) return TRUE;	
	if ((monster_array[monster_nr][2]==LEFT) && GetPix(x-1,y+1)) return TRUE;
	return FALSE;
}


int check_ai_off_cliff(int monster_nr)
{
	int x=monster_array[monster_nr][0],y=monster_array[monster_nr][1];
  SetPlane (LIGHT_PLANE);
	if (monster_array[monster_nr][2]==RIGHT) {
		if (GetPix(x+10,y+8) || GetPix(x+8,y+8)) return FALSE;
	} 
	if (monster_array[monster_nr][2]==LEFT) {
		if (GetPix(x-3,y+8) || GetPix(x-1,y+8)) return FALSE;
	} 
  SetPlane (DARK_PLANE);
	if (monster_array[monster_nr][2]==RIGHT) {
		if (GetPix(x+10,y+8) || GetPix(x+8,y+8)) return FALSE;
	} 
	if (monster_array[monster_nr][2]==LEFT) {
		if (GetPix(x-3,y+8) || GetPix(x-1,y+8)) return FALSE;
	} 
	return TRUE;
}

/*
==================
run_monster()
Handles the monster's movements,
and if something is in it's way..
turn it 180 degrees (sorta the AI of the damn thing)
==================
*/
void run_monsters(void)
{
	int turn=FALSE;
	int monster_nr=0;

	static unsigned char monster_light[] = {0x7E,0xFF,0xFF,0xFF,0x7E,0x7E,0x3C,0x00};
	static unsigned char monster_dark[] = {0x7E,0x81,0xA5,0x81,0x5A,0x42,0x3C,0x66};
	// Okay.. we have the count of how many monsters we got with the monster_count function
	// First off.. Let's run a few bounch/check edge functions.. so the monster turn when
	// it's on it's way into another block.. as well.. if he's on his way off a cliff.. 
	// So he can avoid edges..
  SetPlane (LIGHT_PLANE);
	while (monster_nr<monster_count) {
		turn = check_ai_bounch(monster_nr);
		if (turn) {
			if (monster_array[monster_nr][2]==RIGHT)
				monster_array[monster_nr][2]=LEFT;
			else
				monster_array[monster_nr][2]=RIGHT;
		}
		else {
			turn = check_ai_off_cliff(monster_nr);
			if (turn) {
				if (monster_array[monster_nr][2]==RIGHT)
					monster_array[monster_nr][2]=LEFT;
				else
					monster_array[monster_nr][2]=RIGHT;
			}
			else {
		// Okay.. Move that monster ;)
		// (First erase it..)
			Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_dark, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_light, GetPlane (LIGHT_PLANE), SPRT_XOR);
		
			if (monster_array[monster_nr][2]==RIGHT) monster_array[monster_nr][0]++; 
			if (monster_array[monster_nr][2]==LEFT) monster_array[monster_nr][0]--; 
		
			Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_dark, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_light, GetPlane (LIGHT_PLANE), SPRT_XOR);
			}	
		}
		monster_nr++;
	}
}

/*
==================
check_ai_touch()
checks if a player interfeers/touches
those little cute monsters :)
and if the player do, it returns TRUE
else it returns FALSE
==================
*/
int check_ai_touch(int player_x, int player_y) // Function that checks if a player is close enough to get killed
{
	int monster_nr=0;
	while (monster_nr<monster_count)
	{
		// Do the check if a player is about to get killed *MUHAHAHAH* <evil grin>
		if (((monster_array[monster_nr][0]-9)<player_x) && ((monster_array[monster_nr][0]+9)>player_x)) 
		{ 
		// Okay, we got the player within the monster's area.. Now check if we're on the same height..
			if (((monster_array[monster_nr][1]-9)<player_y) && ((monster_array[monster_nr][1]+9)>player_y)) 
			{ 
				// Allright.. we're here.. Let's return DEATH!!!.. MUHAHAHAHAH
				return TRUE;	
			}
		}
		monster_nr++;
	}
	return FALSE;
}

/*
==================
fix_monster_array
Simply moves all info that is after the "dead"
monster forward 1 cluster. This way we allways
keep the first slots in the array filled with
current monsters.. and the last one allways
opened for new monsters
==================
*/
void fix_monster_array(int monster_nr)
{
	while ((monster_nr+1)<monster_count)
	{
		monster_array[monster_nr][0]=monster_array[monster_nr+1][0];
		monster_array[monster_nr][1]=monster_array[monster_nr+1][1];
		monster_array[monster_nr][2]=monster_array[monster_nr+1][2];
		monster_nr++;
	}
	// Decrease monster_count.... We've lost one of those monsters *sniff* *sniff*
	monster_count--; 
}

/*
==================
ai_follow_scroll
is basicly two functions in one.
The first one is the one that makes sure that the monsters stays on it's correct Y possision when the
map scrolls.. The second one, fixes the stuff up when a monster is going out of bound (Y>120)
note that the dir set's the direction whitch the monster should move
If the map scrolls up, ai_follow_scroll should use (DOWN), cause that's the
direction the monsters should go..
==================
*/
void ai_follow_scroll(int dir)
{
	int monster_nr=0;
	static unsigned char monster_light[] = {0x7E,0xFF,0xFF,0xFF,0x7E,0x7E,0x3C,0x00};
	static unsigned char monster_dark[] = {0x7E,0x81,0xA5,0x81,0x5A,0x42,0x3C,0x66};
	
	while (monster_nr<monster_count)
	{
		// time to take away the monster_sprites
		Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_dark, GetPlane (DARK_PLANE), SPRT_XOR);
		Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_light, GetPlane (LIGHT_PLANE), SPRT_XOR);			
		monster_nr++;
	}
	monster_nr=0;
	while (monster_nr<monster_count)
	{
		// this will increase/decrease monster's Y value No matter if it's going out of bound
		if (dir==DOWN) monster_array[monster_nr][1]+=40;
		if (dir==UP) monster_array[monster_nr][1]-=40;
		monster_nr++;
	}
	monster_nr=0;
	// Now, we need to check if someone have gone out of border..
	while (monster_nr<monster_count)
	{
		if ((monster_array[monster_nr][1]>120) || (monster_array[monster_nr][1]<0)) {
			fix_monster_array(monster_nr);
		} else {  // we need to put this in an else statement, in case the monster with monster_nr+1 also goes out of bound
			// Redraw our monster, and .. off cause.. move on to the next monster
			Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_dark, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(monster_array[monster_nr][0], monster_array[monster_nr][1], 8, monster_light, GetPlane (LIGHT_PLANE), SPRT_XOR);			
			monster_nr++;
		}
	}
}
